from __future__ import print_function
import numpy as np
import math
import cmath

def OutputMisc_HPhi(list_org,Ncond,name_trans): 
    All_N = list_org[0]*list_org[1]*list_org[2]*list_org[3]

    with open("namelist_cg.def", 'w') as f:
        print(" ModPara       modpara.def ", file=f)
        print(" CalcMod       calcmod_cg.def", file=f)
        print(" LocSpin       locspn.def", file=f)
        print(" Trans         %s" %(name_trans), file=f)
        print(" CoulombIntra  coulombintra.def", file=f)
        print(" CoulombInter  coulombinter.def", file=f)
        print(" OneBodyG      green1.def", file=f)
        print(" TwoBodyG      green2.def", file=f)

    with open("calcmod_cg.def", 'w') as f:
        print(" #CalcType = 0:Lanczos, 1:TPQCalc, 2:FullDiag, 3:CG, 4:Time-evolution ", file=f)
        print(" #CalcModel = 0:Hubbard, 1:Spin, 2:Kondo, 3:HubbardGC, 4:SpinGC, 5:KondoGC", file=f)
        print(" #Restart = 0:None, 1:Save, 2:Restart&Save, 3:Restart", file=f)
        print(" #CalcSpec = 0:None, 1:Normal, 2:No H*Phi, 3:Save, 4:Restart, 5:Restart&Save", file=f)
        print(" CalcType       3", file=f)
        print(" CalcModel      0", file=f)
        print(" ReStart        0", file=f)
        print(" CalcSpec       0", file=f)
        print(" CalcEigenVec   0", file=f)
        print(" InitialVecType 0", file=f)
        print(" InputEigenVec  0", file=f)
        print(" OutputEigenVec 0", file=f)

    with open("modpara.def", 'w') as f:
        print("-------------------- ", file=f)
        print("Model_Parameters   0 ", file=f)
        print("-------------------- ", file=f)
        print("HPhi_Cal_Parameters  ", file=f)
        print("-------------------- ", file=f)
        print("CDataFileHead  zvo   ", file=f)
        print("CParaFileHead  zqp   ", file=f)
        print("--------------------  ", file=f)
        print("Nsite          %d "%(All_N), file=f)
        print("2Sz            0  ", file=f)
        print("Ncond          %d  "%(Ncond), file=f)
        print("Lanczos_max    2000 ", file=f)
        print("initial_iv     -1 ", file=f)
        print("exct           1 ", file=f)
        print("LanczosEps     14 ", file=f)
        print("LargeValue     50   ", file=f)
        print("NumAve         5 ", file=f)
        print("ExpecInterval  20 ", file=f)
        print("LanczosTarget  2 ", file=f)

def OutputMisc_mVMC(list_org,Ncond,name_trans): 
    All_N = list_org[0]*list_org[1]*list_org[2]*list_org[3]

    with open("qptrans.def", 'w') as f:
        print("===== ", file=f)
        print("NQPTrans 1   ", file=f)
        print("===== ", file=f)
        print("===== ", file=f)
        print("===== ", file=f)
        print(" %3d %f "%(0,1.0), file=f)
        for all_i in range(0,All_N):
            print(" %3d %3d %3d "%(0,all_i,all_i), file=f)

    with open("namelist_mag.def", 'w') as f:
        print("ModPara        modpara_1.def ", file=f)
        print("LocSpin        locspn.def ", file=f)
        print("Trans          mag_%s" %(name_trans), file=f)
        print("CoulombIntra   coulombintra.def ", file=f)
        print("CoulombInter   coulombinter.def  ", file=f)
        print("Orbital        APOrbital.def  ", file=f)
        print("Gutzwiller     Gutz.def ", file=f)
        print("Jastrow        Jast.def", file=f)
        print("TransSym       qptrans.def", file=f)
        print("OneBodyG       green1.def", file=f)
        print("TwoBodyG       green2.def", file=f)


    with open("namelist_1.def", 'w') as f:
        print("ModPara        modpara_1.def ", file=f)
        print("LocSpin        locspn.def ", file=f)
        print("Trans          %s" %(name_trans), file=f)
        print("CoulombIntra   coulombintra.def ", file=f)
        print("CoulombInter   coulombinter.def  ", file=f)
        print("Orbital        APOrbital.def  ", file=f)
        print("Gutzwiller     Gutz.def ", file=f)
        print("Jastrow        Jast.def", file=f)
        print("TransSym       qptrans.def", file=f)
        print("OneBodyG       green1.def", file=f)
        print("TwoBodyG       green2.def", file=f)

    with open("namelist_2.def", 'w') as f:
        print("ModPara        modpara_2.def ", file=f)
        print("LocSpin        locspn.def ", file=f)
        print("Trans          %s" %(name_trans), file=f)
        print("CoulombIntra   coulombintra.def ", file=f)
        print("CoulombInter   coulombinter.def  ", file=f)
        print("Orbital        APOrbital.def  ", file=f)
        print("Gutzwiller     Gutz.def ", file=f)
        print("Jastrow        Jast.def", file=f)
        print("TransSym       qptrans.def", file=f)
        print("OneBodyG       green1.def", file=f)
        print("TwoBodyG       green2.def", file=f)

    with open("namelist_aft.def", 'w') as f:
        print("ModPara        modpara_aft.def ", file=f)
        print("LocSpin        locspn.def ", file=f)
        print("Trans          %s" %(name_trans), file=f)
        print("CoulombIntra   coulombintra.def ", file=f)
        print("CoulombInter   coulombinter.def  ", file=f)
        print("Orbital        APOrbital.def  ", file=f)
        print("Gutzwiller     Gutz.def ", file=f)
        print("Jastrow        Jast.def", file=f)
        print("TransSym       qptrans.def", file=f)
        print("OneBodyG       green1.def", file=f)
        print("TwoBodyG       green2.def", file=f)

    with open("UHF_namelist.def", 'w') as f:
        print("ModPara        modpara_1.def ", file=f)
        print("LocSpin        locspn.def ", file=f)
        print("Trans          %s" %(name_trans), file=f)
        print("CoulombIntra   coulombintra.def ", file=f)
        print("CoulombInter   coulombinter.def  ", file=f)
        print("Orbital        APOrbital.def  ", file=f)
        print("Gutzwiller     Gutz.def ", file=f)
        print("Jastrow        Jast.def", file=f)
        print("TransSym       qptrans.def", file=f)
        print("OneBodyG       green1.def", file=f)
        print("TwoBodyG       green2.def", file=f)
        print("Initial        initial.def", file=f)

    with open("modpara_1.def", 'w') as f:
        print("-----", file=f)
        print("Model_Parameters 0 ", file=f)
        print("-----", file=f)
        print("VMC_Cal_Parameters ", file=f)
        print("-----", file=f)
        print("CDataFileHead  zvo ", file=f)
        print("CParaFileHead  zqp ", file=f)
        print("-----", file=f)
        print("NVMCCalMode    0 ", file=f)
        print("NLanczosMode   0 ", file=f)
        print("-----", file=f)
        print("NDataIdxStart  1 ", file=f)
        print("NDataQtySmp    5 ", file=f)
        print("-----", file=f)
        print("Nsite          %d " % (All_N), file=f)
        print("Ncond          %d " % (Ncond), file=f)
        print("2Sz            %d " % (0), file=f)
        print("NSPGaussLeg    %d " % (1), file=f)
        print("NSPStot        %d " % (0), file=f)
        print("NMPTrans       %d " % (1), file=f)
        print("NSROptItrStep  %d " % (2000), file=f)
        print("NSROptItrSmp   %d " % (100), file=f)
        print("DSROptRedCut   %.15f " % (1e-8), file=f)
        print("DSROptStaDel   %.15f " % (1e-3), file=f)
        print("DSROptStepDt   %.15f " % (1e-2), file=f)
        print("NVMCWarmUp     %d " % (200), file=f)
        print("NVMCInterval   %d " % (1), file=f)
        print("NVMCSample     %d " % (200), file=f)
        print("NExUpdatePath  %d " % (1), file=f)
        print("RndSeed        %d " % (41272), file=f)
        print("NSplitSize     %d " % (1), file=f)
        print("NStore         %d " % (1), file=f)
    #
    with open("modpara_2.def", 'w') as f:
        print("-----", file=f)
        print("Model_Parameters 0 ", file=f)
        print("-----", file=f)
        print("VMC_Cal_Parameters ", file=f)
        print("-----", file=f)
        print("CDataFileHead  zvo ", file=f)
        print("CParaFileHead  zqp ", file=f)
        print("-----", file=f)
        print("NVMCCalMode    0 ", file=f)
        print("NLanczosMode   0 ", file=f)
        print("-----", file=f)
        print("NDataIdxStart  1 ", file=f)
        print("NDataQtySmp    5 ", file=f)
        print("-----", file=f)
        print("Nsite          %d " % (All_N), file=f)
        print("Ncond          %d " % (Ncond), file=f)
        print("2Sz            %d " % (0), file=f)
        print("NSPGaussLeg    %d " % (8), file=f)
        print("NSPStot        %d " % (0), file=f)
        print("NMPTrans       %d " % (1), file=f)
        print("NSROptItrStep  %d " % (1000), file=f)
        print("NSROptItrSmp   %d " % (100), file=f)
        print("DSROptRedCut   %.15f " % (1e-8), file=f)
        print("DSROptStaDel   %.15f " % (1e-3), file=f)
        print("DSROptStepDt   %.15f " % (1e-2), file=f)
        print("NVMCWarmUp     %d " % (200), file=f)
        print("NVMCInterval   %d " % (1), file=f)
        print("NVMCSample     %d " % (1000), file=f)
        print("NExUpdatePath  %d " % (1), file=f)
        print("RndSeed        %d " % (11272), file=f)
        print("NSplitSize     %d " % (1), file=f)
        print("NStore         %d " % (1), file=f)
 
    #
    with open("modpara_aft.def", 'w') as f:
        print("-----", file=f)
        print("Model_Parameters 0 ", file=f)
        print("-----", file=f)
        print("VMC_Cal_Parameters ", file=f)
        print("-----", file=f)
        print("CDataFileHead  zvo ", file=f)
        print("CParaFileHead  zqp ", file=f)
        print("-----", file=f)
        print("NVMCCalMode    1 ", file=f)
        print("NLanczosMode   0 ", file=f)
        print("-----", file=f)
        print("NDataIdxStart  0 ", file=f)
        print("NDataQtySmp    5 ", file=f)
        print("-----", file=f)
        print("Nsite          %d " % (All_N), file=f)
        print("Ncond          %d " % (Ncond), file=f)
        print("2Sz            %d " % (0), file=f)
        print("NSPGaussLeg    %d " % (8), file=f)
        print("NSPStot        %d " % (0), file=f)
        print("NMPTrans       %d " % (1), file=f)
        print("NSROptItrStep  %d " % (500), file=f)
        print("NSROptItrSmp   %d " % (100), file=f)
        print("DSROptRedCut   %.15f " % (1e-8), file=f)
        print("DSROptStaDel   %.15f " % (1e-3), file=f)
        print("DSROptStepDt   %.15f " % (1e-2), file=f)
        print("NVMCWarmUp     %d " % (200), file=f)
        print("NVMCInterval   %d " % (1), file=f)
        print("NVMCSample     %d " % (1000), file=f)
        print("NExUpdatePath  %d " % (1), file=f)
        print("RndSeed        %d " % (11272), file=f)
        print("NSplitSize     %d " % (1), file=f)
        print("NStore         %d " % (1), file=f)
    #
    with open("UHF_modpara.def", 'w') as f:
        print("-----", file=f)
        print("Model_Parameters 0 ", file=f)
        print("-----", file=f)
        print("VMC_Cal_Parameters ", file=f)
        print("-----", file=f)
        print("CDataFileHead  zvo ", file=f)
        print("CParaFileHead  zqp ", file=f)
        print("-----", file=f)
        print("NVMCCalMode    0 ", file=f)
        print("NLanczosMode   0 ", file=f)
        print("-----", file=f)
        print("NDataIdxStart  1 ", file=f)
        print("NDataQtySmp    5 ", file=f)
        print("-----", file=f)
        print("Nsite          %d " % (All_N), file=f)
        print("Ncond          %d " % (Ncond), file=f)
        print("2Sz            %d " % (0), file=f)
        print("NSPGaussLeg    %d " % (8), file=f)
        print("NSPStot        %d " % (0), file=f)
        print("NMPTrans       %d " % (1), file=f)
        print("NSROptItrStep  %d " % (200), file=f)
        print("NSROptItrSmp   %d " % (100), file=f)
        print("DSROptRedCut   %.15f " % (1e-8), file=f)
        print("DSROptStaDel   %.15f " % (1e-3), file=f)
        print("DSROptStepDt   %.15f " % (1e-2), file=f)
        print("NVMCWarmUp     %d " % (200), file=f)
        print("NVMCInterval   %d " % (1), file=f)
        print("NVMCSample     %d " % (2000), file=f)
        print("NExUpdatePath  %d " % (1), file=f)
        print("RndSeed        %d " % (11272), file=f)
        print("NSplitSize     %d " % (1), file=f)
        print("NStore         %d " % (1), file=f)
        print("Iterationmax   %d " % (20000), file=f)
 


def OutputMisc_Common(list_org): 
    All_N = list_org[0]*list_org[1]*list_org[2]*list_org[3]
    Ncond = int(2*All_N*(3/4))
    with open("locspn.def", 'w') as f:
        print("==================", file=f)
        print("loc %d "%(0), file=f)
        print("==================", file=f)
        print("==================", file=f)
        print("==================", file=f)
        for all_i in range(0,All_N):
            print(" %d %d "% (all_i,0), file=f)

    with open("green1.def", 'w') as f:
        print("==================", file=f)
        print("onebody %d "%(2*All_N**2), file=f)
        print("==================", file=f)
        print("==================", file=f)
        print("==================", file=f)
        for all_i in range(0,All_N):
            for all_j in range(0,All_N):
                print(" %d %d %d %d "% (all_i,0,all_j,0), file=f)
                print(" %d %d %d %d "% (all_i,1,all_j,1), file=f)

    with open("green2.def", 'w') as f:
        print("==================", file=f)
        print("twobody %d "%(6*All_N**2), file=f)
        print("==================", file=f)
        print("==================", file=f)
        print("==================", file=f)
        for all_i in range(0,All_N):
            for all_j in range(0,All_N):
                print(" %d %d %d %d %d %d %d %d"% (all_i,0,all_i,0,all_j,0,all_j,0), file=f)
                print(" %d %d %d %d %d %d %d %d"% (all_i,0,all_i,0,all_j,1,all_j,1), file=f)
                print(" %d %d %d %d %d %d %d %d"% (all_i,1,all_i,1,all_j,0,all_j,0), file=f)
                print(" %d %d %d %d %d %d %d %d"% (all_i,1,all_i,1,all_j,1,all_j,1), file=f)
                #
                print(" %d %d %d %d %d %d %d %d"% (all_i,0,all_j,0,all_j,1,all_i,1), file=f)
                print(" %d %d %d %d %d %d %d %d"% (all_i,1,all_j,1,all_j,0,all_i,0), file=f)
 
